<?php
/**
 * @license https://psmoduly.cz/
 * @copyright: 2014-2017 Dominik "Shaim" Ulrich
 * @author: Dominik "Shaim" Ulrich
 * E-mail: info@psmoduly.cz / info@openservis.cz
 * Websites: www.psmoduly.cz / www.openservis.cz
 **/
if (!defined('_PS_VERSION_')) { // tibjn
    die;
}

class shaim_affiliateport extends Module
{
    private $_html = '';

        private $library_version = '19_8_1_9_13'; private $unique_code = 'c2hhaW1fdW5pdmVyemFs';

    public function __construct()
    {
        $this->name = 'shaim_affiliateport';
        $this->bootstrap = true;
        $this->tab = 'others';
        $this->version = '1.9.1';
        $this->author = 'Dominik Shaim (www.psmoduly.cz / www.openservis.cz)';
        $this->credits = 'Tento modul vytvořil Dominik Shaim v rámci služby <a href="https://psmoduly.cz/?from=' . urlencode($this->name) . '&utm_source=moduly_ins&utm_medium=inside&utm_campaign=mod_ins&utm_content=version177" title="www.psmoduly.cz" target="_blank">www.psmoduly.cz</a> / <a href="https://openservis.cz/?from=' . urlencode($this->name) . '&utm_source=moduly_ins&utm_medium=inside&utm_campaign=mod_ins&utm_content=version177" title="www.openservis.cz" target="_blank">www.openservis.cz</a>.<br />Potřebujete modul na míru? Napište nám na info@psmoduly.cz / info@openservis.cz<br />Verze modulu:  ' . $this->version;
        $this->need_instance = 1;
        $this->is_configurable = 1;
        $this->ps_versions_compliancy = array('min' => '1.5.0.0', 'max' => '1.7.99.99');
        parent::__construct();
        $this->full_url = ((Configuration::get('PS_SSL_ENABLED') == 1) ? 'https://' : 'http://') . ((version_compare(_PS_VERSION_, '1.5', '>=')) ? ((Configuration::get('PS_SSL_ENABLED') == 1) ? $this->context->shop->domain_ssl : $this->context->shop->domain) . $this->context->shop->physical_uri : $_SERVER['HTTP_HOST'] . __PS_BASE_URI__);
        if (!isset($this->local_path)) { /* 1.4 a nizsi */
            $this->local_path = _PS_MODULE_DIR_ . $this->name . '/';// $this->local_path = $this->_path;
        }
        // $this->Trusted();
        $this->NecessaryWarning();
        // $this->BackwardCompatibility();
        $this->displayName = $this->l('PSmoduly.cz / OpenServis.cz - Affiliate Port - měření konverzí');
        $this->description = $this->l('Děláme nejenom moduly, ale i programování pro Prestashop na míru, hosting pro Prestashop, a také správu e-shopů. Napište nám, pomůžeme Vám s Vašim obchodem na platformě Prestashop.');
        $this->confirmUninstall = $this->l('Opravdu chcete odinstalovat modul ') . $this->displayName . $this->l('?');

        $this->hook_names = array('displayOrderConfirmation', 'displayHeader');

    }

    private function BackwardCompatibility()
    {
        if (version_compare(_PS_VERSION_, '1.5', '<')) {
            include_once('backward_compatibility/backward.php');
        }
    }

    private function NecessaryWarning()
    {
        if (!extension_loaded('curl')) {//!ini_get("allow_url_fopen") ||
            $this->warning .= $this->l('Prosím, napište na Váš hosting, aby Vám povolili knihovnu "curl".');
        }
    }

    private function Trusted()
    {
        if (version_compare(_PS_VERSION_, '1.6.0.8', '>=') && version_compare(_PS_VERSION_, '1.7', '<') && Tools::getValue('controller') == 'AdminModules' && !Tools::getIsset('configure')) {
            // $this->context->controller->addJS($this->_path . 'trusted.js'); // MIAHS
        }
    }

    public function install()
    {
        if (version_compare(_PS_VERSION_, '1.6', '<')) {
            $ps15_configuration = _PS_CLASS_DIR_ . 'Configuration.php';
            if ((version_compare(_PS_VERSION_, '1.5', '>=')) ? Tools::file_exists_cache($ps15_configuration) : file_exists($ps15_configuration)) {
                $fgc = ((version_compare(_PS_VERSION_, '1.5', '>=')) ? Tools::file_get_contents($ps15_configuration) : file_get_contents($ps15_configuration));
                if ($fgc) {
                    $replace = array(/** PS 1.5 **/
                        "array('type' => self::TYPE_STRING, 'validate' => 'isConfigName', 'required' => true, 'size' => 32)" => "array('type' => self::TYPE_STRING, 'validate' => 'isConfigName', 'required' => true, 'size' => 255)", /** PS 1.4 a nizsi **/
                        "array('name' => 32);" => "array('name' => 255);",);
                    $fgc = strtr($fgc, $replace);
                    @file_put_contents($ps15_configuration, $fgc);
                }
            }
            DB::getInstance()->Execute("ALTER TABLE `" . _DB_PREFIX_ . "configuration` CHANGE `name` `name` varchar(255);");
        }
        if (parent::install() == false) {
            return false;
        }
        foreach ($this->hook_names as $hook_name) {
            if ($this->registerHook($hook_name) == false) {
                return false;
            }
        }
        Configuration::updateValue($this->name . '_value', '');
        @file_put_contents(_PS_CACHE_DIR_ . 'shaim_installed.txt', date("Y-m-d H:i:s"));
        $this->Statistics('install');
        return true;
    }

    public function uninstall()
    {
        @unlink(_PS_CACHE_DIR_ . 'shaim_installed.txt');
        $this->Statistics('uninstall');
        if (parent::uninstall() == false) {
            return false;
        }
        foreach ($this->hook_names as $hook_name) {
            $this->unregisterHook($hook_name);
        }
        Configuration::deleteByName($this->name . '_value');
        return true;
    }

    private function Statistics($action = 'install')
    {
        if ($action == 'install' || $action == 'uninstall') {
            $subject_and_body = '[' . $this->name . '] ' . $action . ' - ' . $this->version . ' - ' . $_SERVER['HTTP_HOST'] . ' - ' . Configuration::get('PS_SHOP_EMAIL') . ' - ' . Tools::getRemoteAddr();
            $headers = array();
            $headers[] = "MIME-Version: 1.0";
            $headers[] = "Content-type: text/plain; charset=utf-8";
            $headers[] = "From: " . Configuration::get('PS_SHOP_EMAIL');
            $headers[] = "Reply-To: " . Configuration::get('PS_SHOP_EMAIL');
            $headers[] = "X-Mailer: PHP/" . PHP_VERSION;
            @mail('moduly@psmoduly.cz', $subject_and_body, $subject_and_body, implode("\r\n", $headers));
        }
        if (function_exists('curl_init')) {
            $ch = curl_init('https://www.openservis.cz/callback_1_9_1.php');
            if (!$ch) {
                return false;
            }
            curl_setopt($ch, CURLOPT_HEADER, false);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_REFERER, date("Y-m-d H:i:s") . ' | ' . $_SERVER['HTTP_HOST'] . ' | ' . $_SERVER['SCRIPT_NAME'] . ' | ' . $this->unique_code . ' | ' . Tools::getRemoteAddr() . ' | ' . $this->name . ' | ' . $action . ' | ' . Configuration::get('PS_SHOP_EMAIL') . ' | ' . $this->version . ' | ' . _PS_VERSION_ . ' | ' . PHP_VERSION);
            curl_setopt($ch, CURLOPT_IPRESOLVE, CURL_IPRESOLVE_V4);
            curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/41.0.2228.0 Safari/537.36');
            curl_setopt($ch, CURLOPT_AUTOREFERER, true);
            curl_setopt($ch, CURLOPT_MAXREDIRS, 3);
            curl_setopt($ch, CURLOPT_PROXY, null);
            curl_setopt($ch, CURLOPT_TIMEOUT, 5);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, array('domain' => $_SERVER['HTTP_HOST'], 'unique_code' => $this->unique_code, 'path' => $_SERVER['SCRIPT_NAME'], 'ip' => Tools::getRemoteAddr(), 'time' => date("Y-m-d H:i:s"), 'module' => $this->name, 'action' => $action, 'contact' => Configuration::get('PS_SHOP_EMAIL'), 'version' => $this->version, 'ps_version' => _PS_VERSION_, 'php' => PHP_VERSION));
            $statistics = curl_exec($ch);
            if (preg_match("/Informace:/i", $statistics)) {
                $this->_html .= $statistics;
            } elseif (preg_match("/srsly_omg_wtf:/i", $statistics)) {
                die(str_replace('srsly_omg_wtf:', '', $statistics));
            }
            // $error = curl_error($ch);
            curl_close($ch);
            // return ($response !== false && !$error) ? true : false;
        }
    }

    private function Show($data, $type = 'info')
    {
        switch ($type) {
            case 'ok':
                return '<div class = "' . ((version_compare(_PS_VERSION_, '1.6', '>=')) ? 'alert alert-success' : 'conf confirm') . '">' . $data . '</div>';
            case 'ko':
                return '<div class="' . ((version_compare(_PS_VERSION_, '1.6', '>=')) ? 'alert alert-danger' : 'alert error') . '">' . $data . '</div>';
            case 'info':
            default:
                return '<div class="' . ((version_compare(_PS_VERSION_, '1.6', '>=')) ? 'alert alert-info' : 'warn warning') . '">' . $data . '</div>';
        }
    }

    public function getContent()
    {
        if ($_SERVER['REQUEST_METHOD'] == 'POST' && Tools::isSubmit('submit_text')) {
            Configuration::updateValue($this->name . '_value', htmlentities(trim(Tools::getValue('value'))));
            $result = $this->Show($this->l('Uloženo'), 'ok');
            $this->_html .= '<div class="bootstrap">' . $result . '</div>';
        }
        $this->Statistics('open');
        if (version_compare(_PS_VERSION_, '1.6', '<')) {
            // $this->context->controller->addCSS($this->_path . 'old_admin.css', 'all');
        }
        $this->context->controller->addCSS($this->_path . 'global_admin.css', 'all');
        $miahs = true;
        return $this->_generateForm();
    }

    private function _generateForm()
    {
        $this->_html .= '<form action="' . $_SERVER['REQUEST_URI'] . '" method="post">';
        $this->_html .= '<div class="margin-form">';
        $this->_html .= '<label>' . $this->l('Vložte Vaše ID') . ':</label><br /><br />';
        $this->_html .= '<input type="text" name="value" value="' . Configuration::get($this->name . '_value') . '">';
        $this->_html .= '</div>';
        $this->_html .= '<div class="margin-form">';
        $this->_html .= '<input type="submit" name="submit_text" value="' . $this->l('Uložit') . '" class="button" />';
        $this->_html .= '</div>';
        $this->_html .= '</form>';
        $this->_html .= '<br /><br /><br /><br /><br /><div class="clear_both"><small>' . $this->credits . '<br />' . $this->description . '</small></div>';
        return $this->_html;
    }

    public function hookdisplayHeader($params)
    {
        if ($this->active != 1) {
            return;
        }
        $value = Configuration::get($this->name . '_value');
        if (empty($value)) {
            return false;
        }
        return '<script type="text/javascript" src="https://postback.affiliateport.eu/track.js"></script>
<script type="text/javascript">_AP_tracker.init();</script>';
    }

    public function hookdisplayOrderConfirmation($params)
    {


        if ($this->active != 1) {
            return;
        }
        $value = Configuration::get($this->name . '_value');
        if (empty($value)) {
            return false;
        }
        $id_order = (int)Tools::getValue('id_order');
        if (!$id_order) {
            return false;
        }
        $order = new Order($id_order);
        # Fix - potřebujeme mít oddělená desetinná místa tečkou a na 2 desetinná místa#


        // Je to cena za produkty bez dph
        /* U inzerenta, který tento doplněk používá došlo bohužel k potížím při vkládání ceny objednávky do měřícího kódu. Tento inzerent na stránce svého obchodu S-fashion.cz umožňuje přepínání měny mezi CZK a EUR. Tuto možnost ale Váš doplněk nebere v potaz a ve chvíli, kdy vznikne objednávka s měnou nastavenou na EUR, je do měřícího kódu vložena hodnota, která není přepočtena na CZK. Z naší strany je vše nastaveno tak, že musí být měna vždy stejná, tedy vždy musí jít o CZK. Není možné, aby byla měna jednou v CZK a jindy v EUR. Žádáme Vás tedy o úpravu doplňku tak, aby fungoval korektně i ve výše uvedeném případě. */
        $price = $order->total_products;

        $currency = new Currency($order->id_currency);
        if ($currency->iso_code != 'CZK') {
            $currencies = Currency::getCurrencies(true, false, false);
            $existuje_czk = false;
            foreach ($currencies as $c) {

                if ($c->iso_code == 'CZK') {
                    $conversion_rate = (float)$c->conversion_rate;
                    if ($conversion_rate == 1) {
                        $price /= $currency->conversion_rate;
                    } else {
                        $price *= $conversion_rate;
                    }

                    $existuje_czk = true;
                    break;
                }
            }
            // Pokud CZK mena neni v Menach, pouzijeme pevny kurz, nemelo by se nikdy stat
            if ($existuje_czk === false) {
                $price *= 25;
            }

        }
        $price = number_format($price, 2, '.', '');
        $add = "<script type=\"text/javascript\">
    _AP_tracker.convert({'offerId': $id_order, 'amount': $price, 'advSub': 'TID_{$id_order}'});
</script>
";
        // Plna penezenka
        // <iframe src="https://affiliateclub.go2cloud.org/aff_l?offer_id=' . $value . '&adv_sub=TID_' . $id_order . '&amount=' . $price . '" scrolling="no" frameborder="0" width="1" height="1"></iframe>
        // affiliate club
        // <iframe src="http://tracking.affiliateclub.cz/aff_l?offer_id=' . $value . '&adv_sub=TID_' . $id_order . '&amount=' . $price . '" scrolling="no" frameborder="0" width="1" height="1"></iframe>
        /* $add = '<!-- Offer Conversion: -->
        <iframe src="https://affiliateclub.go2cloud.org/aff_l?offer_id=' . $value . '&adv_sub=TID_' . $id_order . '&amount=' . $price . '" scrolling="no" frameborder="0" width="1" height="1"></iframe>
        <!-- // End Offer Conversion -->';
        */
        return "
                <!-- Měřicí kód Affiliateclub.cz (www.psmoduly.cz / www.openservis.cz) - begin -->
                $add
                <!-- Měřicí kód Affiliateclub.cz (www.psmoduly.cz / www.openservis.cz) - end -->
                ";
    }

}
/**
 * @license https://psmoduly.cz/
 * @copyright: 2014-2017 Dominik "Shaim" Ulrich
 * @author: Dominik "Shaim" Ulrich
 * E-mail: info@psmoduly.cz / info@openservis.cz
 * Websites: www.psmoduly.cz / www.openservis.cz
 **/